<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `&#x2F;nix&#x2F;store&#x2F;v9jmyrpcwymx5d6inidy85x2ljzgm935-vendored-sources&#x2F;object-0.27.1&#x2F;src&#x2F;read&#x2F;pe&#x2F;rich.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>rich.rs - source</title><link rel="stylesheet" type="text/css" href="../../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../../../storage.js"></script><script src="../../../../crates.js"></script><noscript><link rel="stylesheet" href="../../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../../../object/index.html'><div class='logo-container rust-logo'><img src='../../../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1"> 1</span>
<span id="2"> 2</span>
<span id="3"> 3</span>
<span id="4"> 4</span>
<span id="5"> 5</span>
<span id="6"> 6</span>
<span id="7"> 7</span>
<span id="8"> 8</span>
<span id="9"> 9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
</pre><pre class="rust"><code><span class="doccomment">//! PE rich header handling</span>

<span class="kw">use</span> <span class="ident">core::mem</span>;

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::pod::bytes_of_slice</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::read::Bytes</span>;
<span class="kw">use</span> <span class="kw">crate</span>::{<span class="ident">pe</span>, <span class="ident">LittleEndian</span> <span class="kw">as</span> <span class="ident">LE</span>, <span class="ident">ReadRef</span>, <span class="ident">U32</span>};

<span class="doccomment">/// Parsed information about a Rich Header.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">RichHeaderInfo</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> {
    <span class="doccomment">/// The offset at which the rich header starts.</span>
    <span class="kw">pub</span> <span class="ident">offset</span>: <span class="ident">usize</span>,
    <span class="doccomment">/// The length (in bytes) of the rich header.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This includes the payload, but also the 16-byte start sequence and the</span>
    <span class="doccomment">/// 8-byte final &quot;Rich&quot; and XOR key.</span>
    <span class="kw">pub</span> <span class="ident">length</span>: <span class="ident">usize</span>,
    <span class="doccomment">/// The XOR key used to mask the rich header.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Unless the file has been tampered with, it should be equal to a checksum</span>
    <span class="doccomment">/// of the file header.</span>
    <span class="kw">pub</span> <span class="ident">xor_key</span>: <span class="ident">u32</span>,
    <span class="ident">masked_entries</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;data</span> [<span class="ident">pe::MaskedRichHeaderEntry</span>],
}

<span class="doccomment">/// A PE rich header entry after it has been unmasked.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// See [`pe::MaskedRichHeaderEntry`].</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>)]</span>
<span class="attribute">#[<span class="ident">repr</span>(<span class="ident">C</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">RichHeaderEntry</span> {
    <span class="doccomment">/// ID of the component.</span>
    <span class="kw">pub</span> <span class="ident">comp_id</span>: <span class="ident">u32</span>,
    <span class="doccomment">/// Number of times this component has been used when building this PE.</span>
    <span class="kw">pub</span> <span class="ident">count</span>: <span class="ident">u32</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> <span class="ident">RichHeaderInfo</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Try to locate a rich header and its entries in the current PE file.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">parse</span><span class="op">&lt;</span><span class="ident">R</span>: <span class="ident">ReadRef</span><span class="op">&lt;</span><span class="lifetime">&#39;data</span><span class="op">&gt;</span><span class="op">&gt;</span>(<span class="ident">data</span>: <span class="ident">R</span>, <span class="ident">nt_header_offset</span>: <span class="ident">u64</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="self">Self</span><span class="op">&gt;</span> {
        <span class="comment">// Locate the rich header, if any.</span>
        <span class="comment">// It ends with the &quot;Rich&quot; string and an XOR key, before the NT header.</span>
        <span class="kw">let</span> <span class="ident">data</span> <span class="op">=</span> <span class="ident">data</span>.<span class="ident">read_bytes_at</span>(<span class="number">0</span>, <span class="ident">nt_header_offset</span>).<span class="ident">map</span>(<span class="ident">Bytes</span>).<span class="ident">ok</span>()<span class="question-mark">?</span>;
        <span class="kw">let</span> <span class="ident">end_marker_offset</span> <span class="op">=</span> <span class="ident">memmem</span>(<span class="ident">data</span>.<span class="number">0</span>, <span class="string">b&quot;Rich&quot;</span>, <span class="number">4</span>)<span class="question-mark">?</span>;
        <span class="kw">let</span> <span class="ident">xor_key</span> <span class="op">=</span> <span class="kw-2">*</span><span class="ident">data</span>.<span class="ident">read_at</span>::<span class="op">&lt;</span><span class="ident">U32</span><span class="op">&lt;</span><span class="ident">LE</span><span class="op">&gt;</span><span class="op">&gt;</span>(<span class="ident">end_marker_offset</span> <span class="op">+</span> <span class="number">4</span>).<span class="ident">ok</span>()<span class="question-mark">?</span>;

        <span class="comment">// It starts at the masked &quot;DanS&quot; string and 3 masked zeroes.</span>
        <span class="kw">let</span> <span class="ident">masked_start_marker</span> <span class="op">=</span> <span class="ident">U32::new</span>(<span class="ident">LE</span>, <span class="number">0x536e_6144</span> <span class="op">^</span> <span class="ident">xor_key</span>.<span class="ident">get</span>(<span class="ident">LE</span>));
        <span class="kw">let</span> <span class="ident">start_header</span> <span class="op">=</span> [<span class="ident">masked_start_marker</span>, <span class="ident">xor_key</span>, <span class="ident">xor_key</span>, <span class="ident">xor_key</span>];
        <span class="kw">let</span> <span class="ident">start_sequence</span> <span class="op">=</span> <span class="ident">bytes_of_slice</span>(<span class="kw-2">&amp;</span><span class="ident">start_header</span>);
        <span class="kw">let</span> <span class="ident">start_marker_offset</span> <span class="op">=</span> <span class="ident">memmem</span>(<span class="kw-2">&amp;</span><span class="ident">data</span>.<span class="number">0</span>[..<span class="ident">end_marker_offset</span>], <span class="ident">start_sequence</span>, <span class="number">4</span>)<span class="question-mark">?</span>;

        <span class="comment">// Extract the items between the markers.</span>
        <span class="kw">let</span> <span class="ident">items_offset</span> <span class="op">=</span> <span class="ident">start_marker_offset</span> <span class="op">+</span> <span class="ident">start_sequence</span>.<span class="ident">len</span>();
        <span class="kw">let</span> <span class="ident">items_len</span> <span class="op">=</span> <span class="ident">end_marker_offset</span> <span class="op">-</span> <span class="ident">items_offset</span>;
        <span class="kw">let</span> <span class="ident">item_count</span> <span class="op">=</span> <span class="ident">items_len</span> <span class="op">/</span> <span class="ident">mem::size_of</span>::<span class="op">&lt;</span><span class="ident">pe::MaskedRichHeaderEntry</span><span class="op">&gt;</span>();
        <span class="kw">let</span> <span class="ident">items</span> <span class="op">=</span> <span class="ident">data</span>.<span class="ident">read_slice_at</span>(<span class="ident">items_offset</span>, <span class="ident">item_count</span>).<span class="ident">ok</span>()<span class="question-mark">?</span>;
        <span class="prelude-val">Some</span>(<span class="ident">RichHeaderInfo</span> {
            <span class="ident">offset</span>: <span class="ident">start_marker_offset</span>,
            <span class="comment">// Includes &quot;Rich&quot; marker and the XOR key.</span>
            <span class="ident">length</span>: <span class="ident">end_marker_offset</span> <span class="op">-</span> <span class="ident">start_marker_offset</span> <span class="op">+</span> <span class="number">8</span>,
            <span class="ident">xor_key</span>: <span class="ident">xor_key</span>.<span class="ident">get</span>(<span class="ident">LE</span>),
            <span class="ident">masked_entries</span>: <span class="ident">items</span>,
        })
    }

    <span class="doccomment">/// Returns an iterator over the unmasked entries.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">unmasked_entries</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw">impl</span> <span class="ident">Iterator</span><span class="op">&lt;</span><span class="ident">Item</span> <span class="op">=</span> <span class="ident">RichHeaderEntry</span><span class="op">&gt;</span> <span class="op">+</span> <span class="lifetime">&#39;data</span> {
        <span class="kw">let</span> <span class="ident">xor_key</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">xor_key</span>;
        <span class="self">self</span>.<span class="ident">masked_entries</span>
            .<span class="ident">iter</span>()
            .<span class="ident">map</span>(<span class="kw">move</span> <span class="op">|</span><span class="ident">entry</span><span class="op">|</span> <span class="ident">RichHeaderEntry</span> {
                <span class="ident">comp_id</span>: <span class="ident">entry</span>.<span class="ident">masked_comp_id</span>.<span class="ident">get</span>(<span class="ident">LE</span>) <span class="op">^</span> <span class="ident">xor_key</span>,
                <span class="ident">count</span>: <span class="ident">entry</span>.<span class="ident">masked_count</span>.<span class="ident">get</span>(<span class="ident">LE</span>) <span class="op">^</span> <span class="ident">xor_key</span>,
            })
    }
}

<span class="doccomment">/// Find the offset of the first occurence of needle in the data.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The offset must have the given alignment.</span>
<span class="kw">fn</span> <span class="ident">memmem</span>(<span class="ident">data</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>], <span class="ident">needle</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>], <span class="ident">align</span>: <span class="ident">usize</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span> {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">offset</span> <span class="op">=</span> <span class="number">0</span>;
    <span class="kw">loop</span> {
        <span class="kw">if</span> <span class="ident">data</span>.<span class="ident">get</span>(<span class="ident">offset</span>..)<span class="question-mark">?</span>.<span class="ident">get</span>(..<span class="ident">needle</span>.<span class="ident">len</span>())<span class="question-mark">?</span> <span class="op">=</span><span class="op">=</span> <span class="ident">needle</span> {
            <span class="kw">return</span> <span class="prelude-val">Some</span>(<span class="ident">offset</span>);
        }
        <span class="ident">offset</span> <span class="op">+</span><span class="op">=</span> <span class="ident">align</span>;
    }
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../../../" data-current-crate="object" data-search-index-js="../../../../search-index.js" data-search-js="../../../../search.js"></div>
    <script src="../../../../main.js"></script><script src="../../../../source-script.js"></script><script src="../../../../source-files.js"></script>
</body></html>